unit IP_camera_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, JPEG, MJPEGDecoderUnit,Number_Avto_Thread_Unit,BMP_To_Jpeg_Thread_Unit;

  
  type
     Tsettings_number_avto=record
        min_width_size_procent:integer;// =1;   //     
        max_width_size_procent:integer;// =100; //     
        Detect_Mode:integer;           // =4;   //   ANPR_DETECTMODE2 | ANPR_DETECTMODE3;
        max_text_size:integer;         // =20;  //     !
        type_number:integer;           // =0;   //   	ANPR_RUSSIAN_BASE
        //     
        x:integer;                     // =0;
        y:integer;                     // =0;
        width:integer;                 // =100;
        height:integer;                // =100;
        number_save_time:integer; //         
  end;

  type
     Tnumber_avto_arr=record
        number:string;              //  
        tim_number_avto:integer;    //    
        time_get:int64;             //     
  end;

  type
     Tnumber_avto=record
        Enabled:boolean;                            //    
        settings_number_avto:Tsettings_number_avto; //    
        number:array of Tnumber_avto_arr;           //   
  end;

type
  TIP_camera = class(TDataModule)
    Timer_Bitmap_to_jpeg: TTimer;                   //      jpeg  bmp
    Timer_connect_attempt: TTimer;                  //     
    Timer_Get_Number_Avto: TTimer;                  //            
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
    procedure Timer_Bitmap_to_jpegTimer(Sender: TObject);
    procedure Timer_connect_attemptTimer(Sender: TObject);
    procedure Timer_Get_Number_AvtoTimer(Sender: TObject);
  private
    { Private declarations }

    tim_delay,FPS_time:int64;
    Timer_Bitmap_to_jpeg_active:boolean;
    FPS_counter:integer;         //  
    MJPEGDecoder_Connected_now:boolean;
    MJPEGDecoder_Connected_time:int64;

    Bitmap_time:int64;
    number_avto_time:int64;
    number_avto_time_last:int64;
    Timer_Get_Number_Avto_active:boolean;
    tim_number_avto_vrem:int64;

    Number_Avto_Thread_List:TThreadList;
    BMP_To_Jpeg_Thread_List:TThreadList;
    Function Number_Avto_Thread_List_Create():boolean;
    Function Number_Avto_Thread_List_Destroy():boolean;
    Function Set_jpeg_Number_Avto_Thread():boolean;
    Function Get_Result_Number_Avto_Thread(var number_avto_string:Tnumber_avto_string):boolean;
    Function Get_Active_Number_Avto_Thread():integer;
    Function Set_Active_Number_Avto_Thread(Active:integer):boolean;

    Function BMP_To_Jpeg_Thread_List_Create():boolean;
    Function BMP_To_Jpeg_Thread_List_Destroy():boolean;
    Function Set_BMP_To_Jpeg_Thread():boolean;
    Function Get_Result_BMP_To_Jpeg_Thread():boolean;
    Function Get_Active_BMP_To_Jpeg_Thread():integer;
    Function Set_Active_BMP_To_Jpeg_Thread(Active:integer):boolean;

    procedure Timer_Bitmap_to_jpeg_Timer();
    procedure Timer_Get_Number_Avto_Timer();

    function  IP_camera_Connected_internal():boolean;
    function  IP_camera_Disconnect_internal():boolean;
    procedure HandleFrame(Sender: TObject; Frame: TMemoryStream);
    procedure HandleError(Sender: TObject; Error: String);
    procedure HandleMessage(Sender: TObject; Msg: String);

  public
    { Public declarations }  
    MJPEGDecoder: TMJPEGDecoder; //     IP 
    //  
    IP_address:string;          // IP  6
    Port:integer;               //  
    Connect_text:string;        //  Connect_text:='/?action=stream?user=admin&pwd=admin&resolution=32';
    number_avto:Tnumber_avto;   //     
    Create_Bitmap:boolean;      //  Bitmap   (****        false****)
    Create_Bitmap_delay:integer;//     Bitmap
    get_Bitmap_to_jpeg_from_Thread:boolean; //  Bitmap   (  (  )     )

    //  
    Bitmap_New_time:int64;      //     Bitmap  jpeg
    Bitmap_New_time_temp:int64; //          tag  
    Jpeg_New_time:int64;        //     jpeg
    Jpeg_New_time_temp:int64;   //          tag  

    load_jpeg:boolean;          //      
    Jpeg:TJPEGImage;            //    Jpeg
    Bitmap:TBitmap;             //    Bitmap
    FPS:integer;                //   Jpeg  
    tim_Assign:integer;         //    jpeg  bmp
    Error_IP_camera: String;    //    
    Msg_IP_camera: String;      //    
    function IP_camera_Connected():boolean;     //    
    function IP_camera_Disconnect():boolean;    //    
    Function Set_settings_Number_Avto():boolean;//      
  end;

implementation

uses jpeg_to_bmp_unit;

{$R *.dfm}

function TIP_camera.IP_camera_Connected_internal():boolean;
begin
  result:=false;
  try
     MJPEGDecoder_Connected_now:=true;
     if (MJPEGDecoder.Connected) then
        begin
            MJPEGDecoder.Disconnect;
        end;
     if not (MJPEGDecoder.Connected) then
        begin
         {   MJPEGDecoder.OnFrame:=nil;
            MJPEGDecoder.OnError:=nil;
            MJPEGDecoder.OnMessage:=nil;
            MJPEGDecoder.Free;
            MJPEGDecoder:=nil;
            MJPEGDecoder:=TMJPEGDecoder.Create(self);   }
            MJPEGDecoder.OnFrame:=HandleFrame;
            MJPEGDecoder.OnError:=HandleError;
            MJPEGDecoder.OnMessage:=HandleMessage;
            MJPEGDecoder.Connect(trim(IP_address),Port,Connect_text);
            result:=MJPEGDecoder.Connected;
            MJPEGDecoder_Connected_time:=GetTickCount;
        end;
  except
  end;
  MJPEGDecoder_Connected_now:=false;
end;

function TIP_camera.IP_camera_Connected():boolean;
begin
  result:=false;
  try
       IP_camera_Connected_internal();
       Timer_connect_attempt.Enabled:=true;
  except
  end;
end;

function TIP_camera.IP_camera_Disconnect_internal():boolean;
begin
   result:=false;
   try
      if (MJPEGDecoder.Connected) then
         begin
            MJPEGDecoder.Disconnect;
            result:=not MJPEGDecoder.Connected;
           { MJPEGDecoder.OnFrame:=nil;
            MJPEGDecoder.OnError:=nil;
            MJPEGDecoder.OnMessage:=nil;
            MJPEGDecoder.Free;
            MJPEGDecoder:=nil;
            MJPEGDecoder:=TMJPEGDecoder.Create(self);   }
         end;
   except
  end;
end;

function TIP_camera.IP_camera_Disconnect():boolean;
begin
   result:=false;
   try
      Timer_connect_attempt.Enabled:=false;
      IP_camera_Disconnect_internal();
   except
  end;
end;

procedure TIP_camera.HandleFrame(Sender: TObject; Frame: TMemoryStream);
begin
  try
  if GetTickCount-tim_delay>1 then  //   
    begin      
      load_jpeg:=true;
      try
         jpeg.Free;
         jpeg:=nil;
         jpeg:=TJPEGImage.Create;
         jpeg.LoadFromStream(Frame);
         FPS_counter:=FPS_counter+1;
         if GetTickCount-FPS_time>1000 then
            begin
                 FPS:=FPS_counter;
                 FPS_counter:=0;
                 FPS_time:=GetTickCount;
            end;
         tim_delay:=GetTickCount;
         Jpeg_New_time:=tim_delay;
      finally
         load_jpeg:=false;
      end;
    end;
 except
 end;
end;

// called when an error occurs; Error contains the error message
procedure TIP_camera.HandleError(Sender: TObject; Error: String);
begin
  Error_IP_camera:=Error;
 // fmMain.Notices.Lines.Add('**** '+Error)
end;

// called when a debug notice occurs; Msg contains the debug message
procedure TIP_camera.HandleMessage(Sender: TObject; Msg: String);
begin
  Msg_IP_camera :=Msg;
  //fmMain.Notices.Lines.Add(Msg)
end;


procedure TIP_camera.DataModuleCreate(Sender: TObject);
begin
    Bitmap_New_time:=0;
    Bitmap_New_time_temp:=0;
    Jpeg_New_time:=0;
    Jpeg_New_time_temp:=0;
    Create_Bitmap_delay:=30;
    Timer_Bitmap_to_jpeg_active:=false;
    Create_Bitmap:=true;
    MJPEGDecoder:=TMJPEGDecoder.Create(self);
    Bitmap:=TBitmap.Create;
    jpeg:=TJPEGImage.Create;
    number_avto.Enabled:=true;
    // 
    number_avto.settings_number_avto.min_width_size_procent:=1;   //     
    number_avto.settings_number_avto.max_width_size_procent:=100; //     
    number_avto.settings_number_avto.Detect_Mode   := 4;     //   ANPR_DETECTMODE2 | ANPR_DETECTMODE3;
    number_avto.settings_number_avto.max_text_size := 20;    //     !
    number_avto.settings_number_avto.type_number := 0;       //   	ANPR_RUSSIAN_BASE
    //     
    number_avto.settings_number_avto.x:=0;
    number_avto.settings_number_avto.y:=0;
    number_avto.settings_number_avto.width:=100;
    number_avto.settings_number_avto.height:=100;
    number_avto.settings_number_avto.number_save_time:=5000;

    Number_Avto_Thread_List_Create();
    BMP_To_Jpeg_Thread_List_Create();
end;

procedure TIP_camera.DataModuleDestroy(Sender: TObject);
begin
    Timer_connect_attempt.Enabled:=false;
    Timer_Bitmap_to_jpeg.Enabled:=false;
    Timer_Get_Number_Avto.Enabled:=false;
    Number_Avto_Thread_List_Destroy();
    BMP_To_Jpeg_Thread_List_Destroy();
    //MJPEGDecoder.Destroy;
    if MJPEGDecoder.Connected then
         MJPEGDecoder.Disconnect;
    MJPEGDecoder.OnFrame:=nil;
    MJPEGDecoder.OnError:=nil;
    MJPEGDecoder.OnMessage:=nil;
    MJPEGDecoder.Free;
    jpeg.Free;
    Bitmap.Free; 
end;

Function TIP_camera.Number_Avto_Thread_List_Create():boolean;
var
  L:TList;
  Number_Avto_Thread : TNumber_Avto_Thread;
begin
   Result:=false;
   try
      if Number_Avto_Thread_List<>nil then
         begin
              Number_Avto_Thread_List_Destroy();
         end;
      if Number_Avto_Thread_List=nil then
         begin
              Number_Avto_Thread_List := TThreadList.Create;
              Number_Avto_Thread := TNumber_Avto_Thread.Create( True ); //CreateSuspended  boolean,  ,       ( false),    ( true).
              Number_Avto_Thread.FreeOnTerminate := True; // FreeOnTerminate ,      
              Number_Avto_Thread.Priority := tpLower;
              // 
              Number_Avto_Thread.settings_get_number_avto.min_width_size_procent:=number_avto.settings_number_avto.min_width_size_procent;   //     
              Number_Avto_Thread.settings_get_number_avto.max_width_size_procent:=number_avto.settings_number_avto.max_width_size_procent; //     
              Number_Avto_Thread.settings_get_number_avto.anpr.Detect_Mode   := number_avto.settings_number_avto.Detect_Mode;     //   ANPR_DETECTMODE2 | ANPR_DETECTMODE3;
              Number_Avto_Thread.settings_get_number_avto.anpr.max_text_size := number_avto.settings_number_avto.max_text_size;    //     !
              Number_Avto_Thread.settings_get_number_avto.anpr.type_number := number_avto.settings_number_avto.type_number;       //   	ANPR_RUSSIAN_BASE
              //     
              Number_Avto_Thread.settings_get_number_avto.RectArea.x:=number_avto.settings_number_avto.x;
              Number_Avto_Thread.settings_get_number_avto.RectArea.y:=number_avto.settings_number_avto.y;
              Number_Avto_Thread.settings_get_number_avto.RectArea.width:=number_avto.settings_number_avto.width;
              Number_Avto_Thread.settings_get_number_avto.RectArea.height:=number_avto.settings_number_avto.height;
              //  
              Number_Avto_Thread.Resume;
              try
                 L := Number_Avto_Thread_List.LockList;
                 L.Add(Number_Avto_Thread);
              finally
                 Number_Avto_Thread_List.UnlockList;
              end;
         end;
      Result:=true;
   except
   end;
end;

Function TIP_camera.Number_Avto_Thread_List_Destroy():boolean;
var
  L:TList;
  Number_Avto_Thread : TNumber_Avto_Thread;
begin
   Result:=false;
   try
      if Number_Avto_Thread_List<>nil then
         begin
              try
                 L := Number_Avto_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       Number_Avto_Thread := TNumber_Avto_Thread(L[0]);
                       if Assigned(Number_Avto_Thread) then
                           begin
                              Number_Avto_Thread.Terminate;  //  
                             // Number_Avto_Thread.Free;
                            //  Number_Avto_Thread:=nil;
                           end;

                       L.Delete(0);
                    end;
              finally
                 Number_Avto_Thread_List.UnlockList;
              end;
              Number_Avto_Thread_List:=nil;
         end;
      Result:=true;
   except
   end;
end;

Function TIP_camera.Set_settings_Number_Avto():boolean;
var
  L:TList;
  Number_Avto_Thread : TNumber_Avto_Thread;
begin

   Result:=false;
   try
      if Number_Avto_Thread_List<>nil then
         begin
              try
                 L := Number_Avto_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       Number_Avto_Thread := TNumber_Avto_Thread(L[0]);
                       if Assigned(Number_Avto_Thread) then
                          begin
                               //Number_Avto_Thread.ID:=ID;
                               // 
                               Number_Avto_Thread.settings_get_number_avto.min_width_size_procent:=number_avto.settings_number_avto.min_width_size_procent;   //     
                               Number_Avto_Thread.settings_get_number_avto.max_width_size_procent:=number_avto.settings_number_avto.max_width_size_procent; //     
                               Number_Avto_Thread.settings_get_number_avto.anpr.Detect_Mode   := number_avto.settings_number_avto.Detect_Mode;     //   ANPR_DETECTMODE2 | ANPR_DETECTMODE3;
                               Number_Avto_Thread.settings_get_number_avto.anpr.max_text_size := number_avto.settings_number_avto.max_text_size;    //     !
                               Number_Avto_Thread.settings_get_number_avto.anpr.type_number := number_avto.settings_number_avto.type_number;       //   	ANPR_RUSSIAN_BASE
                               //     
                               Number_Avto_Thread.settings_get_number_avto.RectArea.x:=number_avto.settings_number_avto.x;
                               Number_Avto_Thread.settings_get_number_avto.RectArea.y:=number_avto.settings_number_avto.y;
                               Number_Avto_Thread.settings_get_number_avto.RectArea.width:=number_avto.settings_number_avto.width;
                               Number_Avto_Thread.settings_get_number_avto.RectArea.height:=number_avto.settings_number_avto.height;
                               result:=true;
                          end;
                    end;
              finally
                 Number_Avto_Thread_List.UnlockList;
              end;
         end;  
   except
   end;  
end;

Function TIP_camera.Set_jpeg_Number_Avto_Thread():boolean;
var
  L:TList;
  Number_Avto_Thread : TNumber_Avto_Thread;
begin
   Result:=false;
   try
      if Number_Avto_Thread_List<>nil then
         begin
              try
                 L := Number_Avto_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       Number_Avto_Thread := TNumber_Avto_Thread(L[0]);
                       if Assigned(Number_Avto_Thread) then
                          begin
                             if Number_Avto_Thread.Active=0 then
                                begin
                                  

                                    if Number_Avto_Thread.MemoryStream<>nil then
                                      begin
                                          Number_Avto_Thread.MemoryStream.Free;
                                          Number_Avto_Thread.MemoryStream:=nil;
                                      end;
                                    Number_Avto_Thread.MemoryStream:=TMemoryStream.Create;
                                    jpeg.SaveToStream(Number_Avto_Thread.MemoryStream);
                                    Number_Avto_Thread.picture_Width:=jpeg.Width;
                                    Number_Avto_Thread.picture_Height:=jpeg.Height;  
                                    Number_Avto_Thread.Active:=1;
                                    Result:=true;
                                end;
                          end;
                    end;
              finally
                 Number_Avto_Thread_List.UnlockList;
              end;
         end;  
   except
   end;
end;

Function TIP_camera.Get_Result_Number_Avto_Thread(var number_avto_string:Tnumber_avto_string):boolean;
var
  L:TList;
  Number_Avto_Thread : TNumber_Avto_Thread;
  i:integer;
begin
   Result:=false;
   try
      if Number_Avto_Thread_List<>nil then
         begin
              try
                 L := Number_Avto_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       Number_Avto_Thread := TNumber_Avto_Thread(L[0]);
                       if Assigned(Number_Avto_Thread) then
                          begin
                             if Number_Avto_Thread.Active=2 then
                                begin
                                    Result:=Number_Avto_Thread.Result;
                                    if Result then
                                        begin
                                           setlength(number_avto_string,length(Number_Avto_Thread.result_number));
                                           for i:=0 to length(Number_Avto_Thread.result_number)-1 do
                                               number_avto_string[i]:=Number_Avto_Thread.result_number[i];
                                        end;
                                    Number_Avto_Thread.Active:=0;
                                end;
                          end;
                    end;
              finally
                 Number_Avto_Thread_List.UnlockList;
              end;
         end;  
   except
   end;
end;

Function TIP_camera.Get_Active_Number_Avto_Thread():integer;
var
  L:TList;
  Number_Avto_Thread : TNumber_Avto_Thread;
begin
   Result:=3;
   try
      if Number_Avto_Thread_List<>nil then
         begin
              try
                 L := Number_Avto_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       Number_Avto_Thread := TNumber_Avto_Thread(L[0]);
                       if Assigned(Number_Avto_Thread) then
                          begin
                             Result:=Number_Avto_Thread.Active;
                          end;
                    end;
              finally
                 Number_Avto_Thread_List.UnlockList;
              end;
         end;  
   except
   end;
end;



Function TIP_camera.Set_Active_Number_Avto_Thread(Active:integer):boolean;
var
  L:TList;
  Number_Avto_Thread : TNumber_Avto_Thread;
begin
   Result:=false;
   try
      if Number_Avto_Thread_List<>nil then
         begin
              try
                 L := Number_Avto_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       Number_Avto_Thread := TNumber_Avto_Thread(L[0]);
                       if Assigned(Number_Avto_Thread) then
                          begin
                             Number_Avto_Thread.Active:=Active;
                             Result:=true;
                          end;
                    end;
              finally
                 Number_Avto_Thread_List.UnlockList;
              end;
         end;
   except
   end;
end;



Function TIP_camera.BMP_To_Jpeg_Thread_List_Create():boolean;
var
  L:TList;
  BMP_To_Jpeg_Thread : TBMP_To_Jpeg_Thread;
begin
   Result:=false;
   try
      if BMP_To_Jpeg_Thread_List<>nil then
         begin
              BMP_To_Jpeg_Thread_List_Destroy();
         end;
      if BMP_To_Jpeg_Thread_List=nil then
         begin
              BMP_To_Jpeg_Thread_List := TThreadList.Create;
              BMP_To_Jpeg_Thread := TBMP_To_Jpeg_Thread.Create( True ); //CreateSuspended  boolean,  ,       ( false),    ( true).
              BMP_To_Jpeg_Thread.FreeOnTerminate := True; // FreeOnTerminate ,      
              BMP_To_Jpeg_Thread.Priority := tpLower;
              //  
              BMP_To_Jpeg_Thread.Resume;
              try
                 L := BMP_To_Jpeg_Thread_List.LockList;
                 L.Add(BMP_To_Jpeg_Thread);
              finally
                 BMP_To_Jpeg_Thread_List.UnlockList;
              end;
         end;
      Result:=true;
   except
   end;
end;

Function TIP_camera.BMP_To_Jpeg_Thread_List_Destroy():boolean;
var
  L:TList;
  BMP_To_Jpeg_Thread : TBMP_To_Jpeg_Thread;
begin
   Result:=false;
   try
      if BMP_To_Jpeg_Thread_List<>nil then
         begin
              try
                 L := BMP_To_Jpeg_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       BMP_To_Jpeg_Thread := TBMP_To_Jpeg_Thread(L[0]);
                       if Assigned(BMP_To_Jpeg_Thread) then
                           begin
                              BMP_To_Jpeg_Thread.Terminate;  //  
                             // BMP_To_Jpeg_Thread.Free;
                            //  BMP_To_Jpeg_Thread:=nil;
                           end;

                       L.Delete(0);
                    end;
              finally
                 BMP_To_Jpeg_Thread_List.UnlockList;
              end;
              BMP_To_Jpeg_Thread_List:=nil;
         end;
      Result:=true;
   except
   end;
end;


Function TIP_camera.Set_BMP_To_Jpeg_Thread():boolean;
var
  L:TList;
  BMP_To_Jpeg_Thread : TBMP_To_Jpeg_Thread;
begin
   Result:=false;
   try
      if BMP_To_Jpeg_Thread_List<>nil then
         begin
              try
                 L := BMP_To_Jpeg_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       BMP_To_Jpeg_Thread := TBMP_To_Jpeg_Thread(L[0]);
                       if Assigned(BMP_To_Jpeg_Thread) then
                          begin
                             if BMP_To_Jpeg_Thread.Active=0 then
                                begin
                                    try
                                       if BMP_To_Jpeg_Thread.Jpeg_Stream<>nil then
                                         begin
                                             BMP_To_Jpeg_Thread.Jpeg_Stream.Free;
                                             BMP_To_Jpeg_Thread.Jpeg_Stream:=nil;
                                         end;
                                    except
                                        BMP_To_Jpeg_Thread.Jpeg_Stream:=nil;
                                    end;
                                  {  try
                                       if BMP_To_Jpeg_Thread.result_Bitmap<>nil then
                                          begin
                                            BMP_To_Jpeg_Thread.result_Bitmap.Free;
                                            BMP_To_Jpeg_Thread.result_Bitmap:=nil;
                                          end;
                                    except
                                        BMP_To_Jpeg_Thread.result_Bitmap:=nil;
                                    end;   }
                                    BMP_To_Jpeg_Thread.Jpeg_Stream:=TMemoryStream.Create;

                                    jpeg.SaveToStream(BMP_To_Jpeg_Thread.Jpeg_Stream);
                                    BMP_To_Jpeg_Thread.Active:=1;
                                    Result:=true;
                                end;
                          end;
                    end;
              finally
                 BMP_To_Jpeg_Thread_List.UnlockList;
              end;
         end;  
   except
   end;
end;

Function TIP_camera.Get_Result_BMP_To_Jpeg_Thread():boolean;
var
  L:TList;
  BMP_To_Jpeg_Thread : TBMP_To_Jpeg_Thread;
begin
   Result:=false;
   try
      if BMP_To_Jpeg_Thread_List<>nil then
         begin
              try
                 L := BMP_To_Jpeg_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       BMP_To_Jpeg_Thread := TBMP_To_Jpeg_Thread(L[0]);
                       if Assigned(BMP_To_Jpeg_Thread) then
                          begin
                             if BMP_To_Jpeg_Thread.Active=2 then
                                begin
                                    if BMP_To_Jpeg_Thread.Result then
                                       begin
                                          Bitmap.Assign(BMP_To_Jpeg_Thread.result_Bitmap);
                                       end;
                                   { try
                                       if BMP_To_Jpeg_Thread.result_Bitmap<>nil then
                                          begin
                                            BMP_To_Jpeg_Thread.result_Bitmap.Free;
                                            BMP_To_Jpeg_Thread.result_Bitmap:=nil;
                                          end;
                                    except
                                        BMP_To_Jpeg_Thread.result_Bitmap:=nil;
                                    end;  }
                                    tim_Assign:=BMP_To_Jpeg_Thread.tim_Assign;
                                    Result:=BMP_To_Jpeg_Thread.Result;
                                    BMP_To_Jpeg_Thread.Active:=0;
                                end;
                          end;
                    end;
              finally
                 BMP_To_Jpeg_Thread_List.UnlockList;
              end;
         end;  
   except
   end;
end;

Function TIP_camera.Get_Active_BMP_To_Jpeg_Thread():integer;
var
  L:TList;
  BMP_To_Jpeg_Thread : TBMP_To_Jpeg_Thread;
begin
   Result:=3;
   try
      if BMP_To_Jpeg_Thread_List<>nil then
         begin
              try
                 L := BMP_To_Jpeg_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       BMP_To_Jpeg_Thread := TBMP_To_Jpeg_Thread(L[0]);
                       if Assigned(BMP_To_Jpeg_Thread) then
                          begin
                             Result:=BMP_To_Jpeg_Thread.Active;
                          end;
                    end;
              finally
                 BMP_To_Jpeg_Thread_List.UnlockList;
              end;
         end;  
   except
   end;
end;

Function TIP_camera.Set_Active_BMP_To_Jpeg_Thread(Active:integer):boolean;
var
  L:TList;
  BMP_To_Jpeg_Thread : TBMP_To_Jpeg_Thread;
begin
   Result:=false;
   try
      if BMP_To_Jpeg_Thread_List<>nil then
         begin
              try
                 L := BMP_To_Jpeg_Thread_List.LockList;
                 if L.Count>0 then
                    begin
                       BMP_To_Jpeg_Thread := TBMP_To_Jpeg_Thread(L[0]);
                       if Assigned(BMP_To_Jpeg_Thread) then
                          begin
                             BMP_To_Jpeg_Thread.Active:=Active;
                             Result:=true;
                          end;
                    end;
              finally
                 BMP_To_Jpeg_Thread_List.UnlockList;
              end;
         end;
   except
   end;
end;

procedure TIP_camera.Timer_connect_attemptTimer(Sender: TObject);
begin
  try
      if MJPEGDecoder.Connected then
         begin //         
             if GetTickCount-Jpeg_New_time>3000 then
                 if GetTickCount-MJPEGDecoder_Connected_time>2000 then
                     IP_camera_Connected_internal();
         end
      else
        if not MJPEGDecoder_Connected_now  then
          if GetTickCount-MJPEGDecoder_Connected_time>2000 then
               IP_camera_Connected_internal();
  except
  end;
end;

procedure TIP_camera.Timer_Bitmap_to_jpeg_Timer();
var tim_vr:int64;
    Frame:TMemoryStream;
begin
   try
      if get_Bitmap_to_jpeg_from_Thread then
        begin
            if (Jpeg_New_time<=0) or (not Create_Bitmap) then
                 exit;
            case Get_Active_BMP_To_Jpeg_Thread() of
               0:begin
                    try
                      if Jpeg_New_time<>Bitmap_time then
                        if GetTickCount-Bitmap_New_time>Create_Bitmap_delay then
                         begin
                             Set_BMP_To_Jpeg_Thread();
                         end;
                    except
                    end;
                 end;
               1:begin //  
                 end;
               2:begin //
                   try
                    Bitmap_time:=GetTickCount;
                    if Get_Result_BMP_To_Jpeg_Thread() then
                       begin
                          Bitmap_New_time:=Jpeg_New_time;
                       end;
                   except
                   end;
                 end;
               3:begin //     
           
                 end;
           end;
       end
   else
       begin
         if Jpeg_New_time<>Bitmap_New_time then
           if GetTickCount-Bitmap_New_time>Create_Bitmap_delay then
             begin
                 tim_vr:=GetTickCount;
     
                 Frame:=TMemoryStream.Create;
                 try
                    Jpeg.SaveToStream(Frame);
                    Frame.Position:=0;
                    LoadBmpFromJpegStream(Bitmap,Frame,true);
                 finally
                    Frame.Free;
                 end;
                 tim_Assign:=GetTickCount-tim_vr;
                 Bitmap_New_time:=Jpeg_New_time;
             end;
        end;
   except
   end;
end;

procedure TIP_camera.Timer_Get_Number_Avto_Timer();
var number_avto_string:Tnumber_avto_string;
   i,j:integer;
   bool_vr:boolean;
   tim_number_avto:int64;
begin
   try
      if (Jpeg_New_time=0) or (not number_avto.Enabled) then
           exit;
      case Get_Active_Number_Avto_Thread() of
        0:begin
             try
             if Jpeg_New_time<>number_avto_time then //      
                if GetTickCount-number_avto_time_last>30 then
                  begin
                      number_avto_time_last:=GetTickCount;
                      tim_number_avto_vrem:=GetTickCount;
                      Set_jpeg_Number_Avto_Thread();
                  end;
             except
             end;
          end;
        1:begin //  
           if GetTickCount-number_avto_time_last>30000 then //       
                Set_Active_Number_Avto_Thread(0);
          end;
        2:begin //
            try
             number_avto_time:=Jpeg_New_time;
             if Get_Result_Number_Avto_Thread(number_avto_string) then
                begin
                   tim_number_avto:=GetTickCount-tim_number_avto_vrem;
                   tim_number_avto_vrem:=GetTickCount;


                   //   
                   try
                   for i:=length(number_avto.number)-1 downto 0 do
                      if tim_number_avto_vrem-number_avto.number[i].time_get>number_avto.settings_number_avto.number_save_time then
                         begin
                            for j:=i+1 to length(number_avto.number)-1 do
                               begin
                                   number_avto.number[j-i-1]:=number_avto.number[j];
                               end;
                            setlength(number_avto.number,length(number_avto.number)-i-1);
                            break;
                         end;
                    except
                    end;
                   //  
                   try
                      for i:=0 to length(number_avto_string)-1 do
                         begin
                             bool_vr:=false;
                             if length(number_avto.number)<=0 then
                                 bool_vr:=true
                             else
                                 if number_avto.number[length(number_avto.number)-1].number<>number_avto_string[i] then
                                     bool_vr:=true;
                             if bool_vr then
                                 begin
                                    setlength(number_avto.number,length(number_avto.number)+1);
                                    number_avto.number[length(number_avto.number)-1].number:=number_avto_string[i];
                                    number_avto.number[length(number_avto.number)-1].time_get:=tim_number_avto_vrem;
                                    number_avto.number[length(number_avto.number)-1].tim_number_avto:=tim_number_avto;
                                 end;
                         end;
                       number_avto_time_last:=GetTickCount;
                    except
                    end;
                end;
            except
            end;
          end;
        3:begin //     
    
          end;
      end;
   except
   end;
end;

procedure TIP_camera.Timer_Bitmap_to_jpegTimer(Sender: TObject);
begin
   try
      if (Timer_Bitmap_to_jpeg_active) then
           exit;
      Timer_Bitmap_to_jpeg_active:=true;
      try
          Timer_Bitmap_to_jpeg_Timer();
      finally
          Timer_Bitmap_to_jpeg_active:=false;
      end;
   except
   end;
end;

procedure TIP_camera.Timer_Get_Number_AvtoTimer(Sender: TObject);
begin
   try
       if (Timer_Get_Number_Avto_active) then
          exit;
      Timer_Get_Number_Avto_active:=true;
      try
          Timer_Get_Number_Avto_Timer();  
      finally
          Timer_Get_Number_Avto_active:=false;
      end;
   except
   end;
end;

end.
