unit Number_Avto_Thread_Unit;

interface

uses
  Windows,Classes,Graphics,JPEG,SysUtils,Math;

  type
     Tnumber_avto_string=array of string;

  type
     ANPR_OPTIONS = Record
        min_plate_size:integer;
     	  max_plate_size:integer;
       	Detect_Mode:integer;
       	max_text_size:integer;
     	  type_number:integer;
        flags:integer;
  end;

  type
     CvRect = Record
        x:integer;
        y:integer;
        width:integer;
        height:integer;
  end;
  type
    PRect = ^CvRect;

  type
     Tsettings_get_number_avto=record
        min_width_size_procent:integer;
     	  max_width_size_procent:integer;
        anpr: ANPR_OPTIONS;
        RectArea: CvRect;
  end;

type
  TNumber_Avto_Thread = class(TThread)
  private
    { Private declarations }

    Function get_number_avto(var number:Tnumber_avto_string):boolean;
  protected
     procedure Execute; override;
  public
     settings_get_number_avto:Tsettings_get_number_avto; //   
     Active:integer;                                     //   (=1   )
     //   
     MemoryStream: TMemoryStream;       //   jpeg   bmp
     picture_Width:integer;             //  
     picture_Height:integer;           //  
     //  
     result:boolean;                   //    
     result_number:Tnumber_avto_string;//   
     tim_Assign:integer;               //      (  )
  end;

implementation

//anprPlateMemory( char* in_buffer, long  size_buffer, ANPR_OPTIONS Options, int* AllNumber, CvRect* Rects, char** Texts )
//    
function anprPlateMemoryRect( in_buffer: PChar; size_buffer: integer; Rect: CvRect; Options: ANPR_OPTIONS; AllNumber: PInt; Rects: PRect; Texts: PPChar ): integer; stdcall; external 'iANPR_vc10_x86.dll' name 'anprPlateMemoryRect';

Function TNumber_Avto_Thread.get_number_avto(var number:Tnumber_avto_string):boolean;
var
   p:PChar;
   r,s,i:integer;
   rect: array [0..99] of CvRect;
   pr: PRect;
   ptext: array of PChar;
   all: integer;
   RectArea: CvRect;
begin
   result:=false;
   if (MemoryStream=nil) or (picture_Width<=0) or (picture_Height<=0) then
     exit;
   try
      SetLength(number,0);
      settings_get_number_avto.anpr.min_plate_size:= round(0.22*Power(picture_Width*settings_get_number_avto.min_width_size_procent/100,2));      //     
      settings_get_number_avto.anpr.max_plate_size:= round(0.22*Power(picture_Width*settings_get_number_avto.max_width_size_procent/100,2));   //    
      settings_get_number_avto.anpr.flags:=0;
      RectArea.x:= round(picture_Width*settings_get_number_avto.RectArea.x/100);
      RectArea.y:= round(picture_Height*settings_get_number_avto.RectArea.y/100);
      RectArea.width:= round(picture_Width*settings_get_number_avto.RectArea.width/100);
      RectArea.height:= round(picture_Height*settings_get_number_avto.RectArea.height/100);
      try
          MemoryStream.Position:=0;
          GetMem(p, MemoryStream.Size);
          MemoryStream.read(p^, MemoryStream.Size);
          s := MemoryStream.Size;
      finally
         MemoryStream.free;
         MemoryStream:=nil;
      end;
      try
         all := 10;
         pr := @rect;
         setlength(ptext,all);
         for i := 0 to all-1 do
            GetMem(ptext[i], settings_get_number_avto.anpr.max_text_size *sizeof(char));
         r := anprPlateMemoryRect(p, s, RectArea, settings_get_number_avto.anpr, @all, pr, @ptext[0]);
         if ( r = 0 ) and ( all > 0 ) then
            for i := 0 to all-1 do
               if length(ptext[i])>=6 then
                  begin
                     setlength(number,length(number)+1);
                     number[length(number)-1]:=ptext[i];
                     result:=true;
                  end;
      finally
         FreeMem(p);
         for i := 0 to all-1 do
             FreeMem(ptext[i]);
      end;
   except
   end;
end;

procedure TNumber_Avto_Thread.Execute;
var tim_vr:int64;
begin
    repeat
         if Active=1 then
           begin
              result:=false;
              try
                 tim_vr:=GetTickCount;
                 setlength(result_number,0);
                 result:=get_number_avto(result_number);
                 tim_Assign:=GetTickCount-tim_vr;
              except
                 result:=false;
              end;
              Active:=2;
           end;
        sleep(5);
    until Terminated;
    if MemoryStream<>nil then
       begin
           try
              MemoryStream.Free;
              MemoryStream:=nil;
           except
           end;
       end;
end;

end.
