unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,IP_camera_Unit,JPEG;


  type
     Tsettings_IP_camera=record
         IP_address:string;        // IP  6
         Port:integer;             //  
         Connect_text:string;      //  Connect_text:='/?action=stream?user=admin&pwd=admin&resolution=32';
         Get_number_avto:boolean;  //     
         Create_Bitmap:boolean;    //  Bitmap   (****        false****)
         get_Bitmap_to_jpeg_from_Thread:boolean; //  Bitmap   (  (  )     )
  end;

  type
     Tdata_temp_IP_camera_my=record
         FPS_time:int64;          //   FPS
  end;

  type
     TIP_camera_my=record
        Enamled:boolean;                           //     
        FPS_not_more_on_Image:integer;             //   


        settings_number_avto:Tsettings_number_avto;//    
        settings_IP_camera:Tsettings_IP_camera;    //   IP 
        IP_camera:TIP_camera;                      //        
        data_temp:Tdata_temp_IP_camera_my          //    
  end;


type
  TfmMain = class(TForm)
    Timer_refresh_ip_Image: TTimer;
    Panel1: TPanel;
    Image_IP_camera0: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    Panel2: TPanel;
    Image_IP_camera1: TImage;
    Memo2: TMemo;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    CheckBox2: TCheckBox;
    Panel3: TPanel;
    Button1: TButton;
    Splitter1: TSplitter;
    procedure Button1Click(Sender: TObject);
    procedure Timer_refresh_ip_ImageTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    Timer1_Active:boolean;
  public
    { Public declarations }
    IP_camera:array of TIP_camera_my; //    
    procedure IP_camera_Load_settings();
    Function IP_camera_Create(var IP_camera:TIP_camera):boolean;                                                              //        
    Function IP_camera_Destroy(var IP_camera:TIP_camera):boolean;                                                             //        
    function IP_camera_Connected(var IP_camera:TIP_camera; IP_address:string; Port:integer; Connect_text:string; Create_Bitmap:boolean; get_number_avto:boolean):boolean; //   
    function IP_camera_Disconnect(var IP_camera:TIP_camera):boolean;                                                          //   
    function IP_camera_Set_settings_Number_Avto(var IP_camera:TIP_camera; settings_number_avto:Tsettings_number_avto):boolean;//    
    function IP_camera_get_jpeg(var IP_camera:TIP_camera; var jpeg:TJPEGImage):boolean;                                       //       jpeg
    function IP_camera_get_bmp(var IP_camera:TIP_camera; var bmp:TBitmap):boolean;                                            //       bmp
    Function IP_camera_set_quality_pictures_on_Image(Image:TImage; quality_pictures_on_Image:integer):boolean;               //     (   Image    jpeg)
  end;

var
  fmMain: TfmMain;   

implementation

{$R *.dfm}



Function TfmMain.IP_camera_set_quality_pictures_on_Image(Image:TImage; quality_pictures_on_Image:integer):boolean;
begin
   Result:=false;
   try
      if Image=nil then
          exit;
      if Image.Picture.Graphic=nil then
          exit;
      case quality_pictures_on_Image of
        0:if TJPEGImage(Image.Picture.Graphic).Scale<>jsFullSize then
               TJPEGImage(Image.Picture.Graphic).Scale := jsFullSize;
        1:if TJPEGImage(Image.Picture.Graphic).Scale<>jsHalf then
               TJPEGImage(Image.Picture.Graphic).Scale := jsHalf;
        2:if TJPEGImage(Image.Picture.Graphic).Scale<>jsQuarter then
               TJPEGImage(Image.Picture.Graphic).Scale := jsQuarter;
        else
            if TJPEGImage(Image.Picture.Graphic).Scale<>jsEighth then
                  TJPEGImage(Image.Picture.Graphic).Scale := jsEighth;
      end;
      Result:=true;
   except
   end;
end;


Function TfmMain.IP_camera_Create(var IP_camera:TIP_camera):boolean;
begin
   Result:=false;
   try
      if IP_camera<>nil then
         begin
              IP_camera_Destroy(IP_camera);
         end;
      if IP_camera=nil then
         begin
              IP_camera:=TIP_camera.Create(nil);
         end;
      Result:=true;
   except
   end;
end;

Function TfmMain.IP_camera_Destroy(var IP_camera:TIP_camera):boolean;
begin
   Result:=false;
   try
      if IP_camera<>nil then
         begin
            IP_camera.Free;
            IP_camera:=nil;
         end;
      Result:=true;
   except
   end;
end;

function TfmMain.IP_camera_Connected(var IP_camera:TIP_camera; IP_address:string; Port:integer; Connect_text:string; Create_Bitmap:boolean; get_number_avto:boolean):boolean;
begin
   Result:=false;
   try
       if IP_camera=nil then
          exit;
       IP_camera.IP_address:=IP_address;
       IP_camera.Port:=Port;
       IP_camera.Connect_text:=Connect_text;  //  Connect_text:='/?action=stream?user=admin&pwd=admin&resolution=32';
       IP_camera.Create_Bitmap:=Create_Bitmap;//  Bitmap
       IP_camera.Create_Bitmap_delay:=0;
       IP_camera.get_Bitmap_to_jpeg_from_Thread:=false;
       IP_camera.number_avto.Enabled:=get_number_avto;
       result:=IP_camera.IP_camera_Connected();
   except
   end;
end;

function TfmMain.IP_camera_Disconnect(var IP_camera:TIP_camera):boolean;
begin
   Result:=false;
   try
       if IP_camera=nil then
          exit;
       result:=IP_camera.IP_camera_Disconnect();
   except
   end;
end;

function TfmMain.IP_camera_Set_settings_Number_Avto(var IP_camera:TIP_camera; settings_number_avto:Tsettings_number_avto):boolean;
begin
   Result:=false;
   try
       if IP_camera=nil then
          exit;
       //    
       IP_camera.number_avto.settings_number_avto.min_width_size_procent:=settings_number_avto.min_width_size_procent; //=1;   //     
       IP_camera.number_avto.settings_number_avto.max_width_size_procent:=settings_number_avto.max_width_size_procent; //=100; //     
       IP_camera.number_avto.settings_number_avto.Detect_Mode   := settings_number_avto.Detect_Mode;                   //=4;   //   ANPR_DETECTMODE2 | ANPR_DETECTMODE3;
       IP_camera.number_avto.settings_number_avto.max_text_size := settings_number_avto.max_text_size;                 //=20;  //     !
       IP_camera.number_avto.settings_number_avto.type_number := settings_number_avto.type_number;                     //=0;   //   	ANPR_RUSSIAN_BASE
       //     
       IP_camera.number_avto.settings_number_avto.x:=settings_number_avto.x;                                           //=0;
       IP_camera.number_avto.settings_number_avto.y:=settings_number_avto.y;                                           //=0;
       IP_camera.number_avto.settings_number_avto.width:=settings_number_avto.width;                                   //=100;
       IP_camera.number_avto.settings_number_avto.height:=settings_number_avto.height;                                 //=100;
       IP_camera.number_avto.settings_number_avto.number_save_time:=settings_number_avto.number_save_time;             //=5000; //         

       IP_camera.Set_settings_Number_Avto();
   except
   end;
end;

function TfmMain.IP_camera_get_bmp(var IP_camera:TIP_camera; var bmp:TBitmap):boolean;
begin
   Result:=false;
   try
       if IP_camera=nil then
          exit;
       if (IP_camera.Bitmap_New_time>0) and (IP_camera.Bitmap_New_time<>IP_camera.Bitmap_New_time_temp) then
           begin
              IP_camera.Bitmap_New_time_temp:=IP_camera.Bitmap_New_time;
              bmp:=TBitmap.Create;
              bmp.Assign(IP_camera.Bitmap);
              result:=true;
           end;
   except
   end;
end;

function TfmMain.IP_camera_get_jpeg(var IP_camera:TIP_camera; var jpeg:TJPEGImage):boolean;
var Frame: TMemoryStream;

begin
   Result:=false;
   try
       //GetTickCount
       if IP_camera=nil then
          exit;
       if (IP_camera.jpeg_New_time>0) and (IP_camera.jpeg_New_time<>IP_camera.jpeg_New_time_temp) then
           begin
              IP_camera.jpeg_New_time_temp:=IP_camera.jpeg_New_time;
              jpeg:=TJPEGImage.Create;
              Frame:=TMemoryStream.Create;
              try
                  IP_camera.Jpeg.SaveToStream(Frame);
                  Frame.Position:=0;
                  jpeg.LoadFromStream(Frame);
              finally
                  Frame.Free;
              end;
             // jpeg.Assign(IP_camera.Jpeg);
              result:=true;
           end;
   except
   end;
end;

procedure TfmMain.IP_camera_Load_settings();
begin
  if length(IP_camera)<=0 then
      begin
          setlength(IP_camera,10);
          //    
          IP_camera_Create(IP_camera[0].IP_camera);
          //*************  (     )*****************************
          IP_camera[0].Enamled:=true;
          IP_camera[0].FPS_not_more_on_Image:=20;
          //    
          IP_camera[0].settings_number_avto.min_width_size_procent:=1;   //     
          IP_camera[0].settings_number_avto.max_width_size_procent:=100; //     
          IP_camera[0].settings_number_avto.Detect_Mode:=4;              //   ANPR_DETECTMODE2 | ANPR_DETECTMODE3;
          IP_camera[0].settings_number_avto.max_text_size:=20;           //     !
          IP_camera[0].settings_number_avto.type_number:=0;              //   	ANPR_RUSSIAN_BASE
          //     
          IP_camera[0].settings_number_avto.x:=0;
          IP_camera[0].settings_number_avto.y:=0;
          IP_camera[0].settings_number_avto.width:=100;
          IP_camera[0].settings_number_avto.height:=100;
          IP_camera[0].settings_number_avto.number_save_time:=5000;      //         
          IP_camera[0].settings_IP_camera.IP_address:='192.168.3.99';
          IP_camera[0].settings_IP_camera.Port:=8008;
          IP_camera[0].settings_IP_camera.Connect_text:=''; //Connect_text:='/?action=stream?user=admin&pwd=admin&resolution=32';
          IP_camera[0].settings_IP_camera.Create_Bitmap:=true;
          IP_camera[0].settings_IP_camera.get_Bitmap_to_jpeg_from_Thread:=true;
          IP_camera[0].settings_IP_camera.get_number_avto:=true;

           if length(IP_camera)>1 then
              begin
                 IP_camera_Create(IP_camera[1].IP_camera);
                 IP_camera[1].Enamled:=true;
                 IP_camera[1].settings_IP_camera:=IP_camera[0].settings_IP_camera;
              end;
      end;

   IP_camera[0].settings_IP_camera.IP_address:=trim(Edit1.Text);
   IP_camera[0].settings_IP_camera.Port:=strtoint(trim(Edit2.Text));
   IP_camera[0].settings_IP_camera.Connect_text:=Edit3.Text; //Connect_text:='/?action=stream?user=admin&pwd=admin&resolution=32';
   IP_camera[0].settings_IP_camera.get_number_avto:=CheckBox1.Checked;

   if length(IP_camera)>1 then
       begin
          IP_camera[1].settings_number_avto:=IP_camera[0].settings_number_avto;
          IP_camera[1].settings_IP_camera.IP_address:=trim(Edit4.Text);
          IP_camera[1].settings_IP_camera.Port:=strtoint(trim(Edit5.Text));
          IP_camera[1].settings_IP_camera.Connect_text:=Edit6.Text; //Connect_text:='/?action=stream?user=admin&pwd=admin&resolution=32';
          IP_camera[1].settings_IP_camera.get_number_avto:=CheckBox2.Checked;
          IP_camera[1].FPS_not_more_on_Image:=IP_camera[0].FPS_not_more_on_Image;
       end;
end;


procedure TfmMain.Button1Click(Sender: TObject);
var i:integer;
begin
   IP_camera_Load_settings();

   for i:=0 to length(IP_camera)-1 do
      begin
          IP_camera_Set_settings_Number_Avto(IP_camera[i].IP_camera,IP_camera[i].settings_number_avto);
          if (IP_camera[i].Enamled) and (not IP_camera[i].IP_camera.MJPEGDecoder.Connected) then
              IP_camera_Connected(IP_camera[i].IP_camera,IP_camera[i].settings_IP_camera.IP_address,IP_camera[i].settings_IP_camera.Port,IP_camera[i].settings_IP_camera.Connect_text,IP_camera[i].settings_IP_camera.Create_Bitmap,IP_camera[i].settings_IP_camera.get_number_avto)
          else
              IP_camera_Disconnect(IP_camera[i].IP_camera);
      end;
end;

procedure TfmMain.Timer_refresh_ip_ImageTimer(Sender: TObject);
var bmp:TBitmap;
    i:integer;
begin
 try
   if Timer1_Active then
     exit;
   Timer1_Active:=true;
   try
       if length(IP_camera)=0 then
         exit;
       if IP_camera[0].IP_camera<>nil then
          begin
              fmMain.Caption:='IP camera MJPEG    '+'FPS camera: '+inttostr(IP_camera[0].IP_camera.FPS){+'  Tim_Assign: '+inttostr(IP_camera[0].IP_camera.tim_Assign)};
          end;
    
       for i:=0 to length(IP_camera)-1 do
          begin
             try
                if IP_camera[i].Enamled then
                  if GetTickCount-IP_camera[i].data_temp.FPS_time>1000/IP_camera[i].FPS_not_more_on_Image then
                     begin
                        IP_camera[i].data_temp.FPS_time:=GetTickCount;
                        if TImage(FindComponent('Image_IP_camera'+inttostr(i)))<>nil then
                         if TImage(FindComponent('Image_IP_camera'+inttostr(i))).Visible then
                           if IP_camera_get_bmp(IP_camera[i].IP_camera,bmp) then
                              begin
                                 try   
                                      TImage(FindComponent('Image_IP_camera'+inttostr(i))).Picture.Bitmap.Assign(bmp);
                                 except
                                   ShowMessage(inttostr(i)+'  Picture.Assign(bmp)');
                                 end;
                                 try
                                       IP_camera_set_quality_pictures_on_Image(TImage(FindComponent('Image_IP_camera'+inttostr(i))),1);
                                 except
                                 end;
                                 try
                                   bmp.Free;
                                   bmp:=nil;
                                 except
                                 end;
                              end;
                     end;
              except
              end;
          end;
       try
       if length(IP_camera[0].IP_camera.number_avto.number)>0 then
          begin
             for i:=0 to length(IP_camera[0].IP_camera.number_avto.number)-1 do
               begin
                    if IP_camera[0].IP_camera.number_avto.number[i].number<>'B626AK177' then
                         Memo1.Lines.Add(IP_camera[0].IP_camera.number_avto.number[i].number+'    Time: '+inttostr(IP_camera[0].IP_camera.number_avto.number[i].tim_number_avto)+'   Error nom')
                    else
                         Memo1.Lines.Add(IP_camera[0].IP_camera.number_avto.number[i].number+'    Time: '+inttostr(IP_camera[0].IP_camera.number_avto.number[i].tim_number_avto));
               end;
              try
                    setlength(IP_camera[0].IP_camera.number_avto.number,0);
              except
              end;
          end;
      except
      end;
      try
       if length(IP_camera)>1 then
       if length(IP_camera[1].IP_camera.number_avto.number)>0 then
          begin
             for i:=0 to length(IP_camera[1].IP_camera.number_avto.number)-1 do
               begin
                    if IP_camera[1].IP_camera.number_avto.number[i].number<>'B626AK177' then
                         Memo2.Lines.Add(IP_camera[1].IP_camera.number_avto.number[i].number+'    Time: '+inttostr(IP_camera[1].IP_camera.number_avto.number[i].tim_number_avto)+'   Error nom')
                    else
                         Memo2.Lines.Add(IP_camera[1].IP_camera.number_avto.number[i].number+'    Time: '+inttostr(IP_camera[1].IP_camera.number_avto.number[i].tim_number_avto));
               end;
              try
                    setlength(IP_camera[1].IP_camera.number_avto.number,0);
              except
              end;
          end;
      except
      end;  
    finally
       Timer1_Active:=false;
    end;
   except
   end;
end;

procedure TfmMain.FormCreate(Sender: TObject);
begin
 Timer1_Active:=false;
end;

procedure TfmMain.FormResize(Sender: TObject);
begin
  Panel1.Width:=(fmMain.ClientWidth div 2);
  Panel1.Height:=Panel3.Top;
  Panel1.Left:=0;
  Panel1.top:=0;


  Panel2.Width:=Panel1.Width;
  Panel2.Height:=Panel1.Height;
  Panel2.Left:=Panel1.Left+Panel1.Width;
  Panel2.top:=0;

end;

procedure TfmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var i:integer;
begin
    Timer_refresh_ip_Image.Enabled:=false;
    try
       for i:=0 to length(IP_camera)-1 do
          IP_camera_Destroy(IP_camera[i].IP_camera);
    except
    end;
end;

end.
